package Jcg.polyhedron;

import Jcg.geometry.*;


/**
 * Class for representing half-edges
 *
 * @author Code by Luca Castelli Aleardi (INF555, 2012)

 */
public class Halfedge<X extends Point_> {

public Halfedge next;
public Halfedge opposite;
public Vertex vertex;

//public Halfedge<X> prev;
public int index;

	public void setNext(Halfedge e) { this.next=e; }
	public void setOpposite(Halfedge e) { this.opposite=e; }
	//public void setPrev(Halfedge<X> e) { this.prev=e; }
	public void setVertex(Vertex v) { this.vertex=v; }
	
	public Halfedge getNext() { return this.next; }
	public Halfedge getOpposite() { return this.opposite; }
	public Halfedge getPrev() { return this.next.next; }
	public Vertex getVertex() { return this.vertex; }
	
    public Halfedge() {}
    
    public String toString(){
    	return "("+opposite.getVertex().index+" - "+vertex.index+")";
    }
    
	@Override
	public boolean equals(Object o) {
		Halfedge e=(Halfedge)o;
		//if(this.vertex==null && this.next==null)
		//	return false;
		
		//System.out.print("\t Cheching edges "+this.index+", "+e.index);
		if(this.vertex.index==e.vertex.index && this.next.next.vertex.index==e.next.next.vertex.index) {
			//System.out.println(" equal");
			return true;
		}
		if(this.vertex.index==e.next.next.vertex.index && this.next.next.vertex.index==e.vertex.index) {
			//System.out.println("equal");
			return true;
		}
		
		//System.out.println(" different");
		return false;
	}
	
	@Override
	public int hashCode() {
		return this.vertex.index*this.next.next.vertex.index;
	}

}


