package Jcg.polyhedron;

import java.util.LinkedList;
import java.util.List;

import Jcg.geometry.*;


public class Vertex<X extends Point_>{

Halfedge halfedge=null;
//X point=null;
public int index;

    public Vertex() {}

    public void setEdge(Halfedge halfedge) { this.halfedge=halfedge; }
    
    public Halfedge getHalfedge() { return this.halfedge; } 
    
    public String toString(){
        return "v"+index;
    }
    
    /**
     * Return the list of (outgoing) halfedges incident to the vertex <p>
     * 
     * Remark: Half-edges are listed in cw order
     */
    public List<Halfedge> getOutgoingHalfedges() {
    	LinkedList<Halfedge> result=new LinkedList<Halfedge>();
    	Halfedge e=this.getHalfedge(); // halfedge incident to v (having v as destination)
    	result.add(e.getOpposite());
    	
    	Halfedge pEdge=e.getNext().getOpposite();
    	while(pEdge!=e) {
    		result.add(pEdge.getOpposite()); // get the opposite half-edge (outgoing from v)
    		pEdge=pEdge.getNext().getOpposite(); // get next hafledge arounf v in cw order
    	}
    	return result;
    }

}


